//	Ex4.c
//	This version introduces the use of graphics, JavaScript and CSS.

static char szEx4[] =
	"<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\r\n"
	"<html xmlns=\"http://www.w3.org/1999/xhtml\">\r\n"
	"<head>\r\n"
	"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" />\r\n"
	"<title>Microwave Control Panel</title>\r\n"
	"<link href=\"esc.css\" rel=\"stylesheet\" type=\"text/css\" />\r\n"
	"<script src=\"esc.js\" type=\"application/x-javascript\"></script>\r\n"
	"</head>\r\n"
	"<body>\r\n"
	"<div><img src=\"top.gif\" border=\"0\" /></div>\r\n"
	"<table align=\"center\" class=\"pan\" border=\"0\" cellspacing=\"5\" cellpadding=\"0\">\r\n"
	" <tr><td colspan=\"3\">\r\n"
	"  <table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n"
	"   <tr>\r\n"
	"	<td class=\"rd\"><span id=\"door\">&nbsp;</span><br /><span id=\"run\">&nbsp;</span></td>\r\n"
	"	<td><img id=\"d0\" src=\"x.gif\" border=\"0\" /></td>\r\n"
	"	<td><img id=\"d1\" src=\"x.gif\" border=\"0\" /></td>\r\n"
	"	<td><img src=\"c.gif\" border=\"0\" /></td>\r\n"
	"	<td><img id=\"d2\" src=\"x.gif\" border=\"0\" /></td>\r\n"
	"	<td><img id=\"d3\" src=\"0.gif\" border=\"0\" /></td>\r\n"
	"	<td class=\"pd\">&nbsp;<br /><span id=\"pwr\">&nbsp;</span></td>\r\n"
	"   </tr>\r\n"
	"  </table>\r\n"
	" </td></tr>\r\n"
	" <tr class=\"r3\">\r\n"
	"  <td><a href=\"javascript:dig(1);\">1</a></td>\r\n"
	"  <td><a href=\"javascript:dig(2);\">2</a></td>\r\n"
	"  <td><a href=\"javascript:dig(3);\">3</a></td>\r\n"
	" </tr>\r\n"
	" <tr class=\"r3\">\r\n"
	"  <td><a href=\"javascript:dig(4);\">4</a></td>\r\n"
	"  <td><a href=\"javascript:dig(5);\">5</a></td>\r\n"
	"  <td><a href=\"javascript:dig(6);\">6</a></td>\r\n"
	" </tr>\r\n"
	" <tr class=\"r3\">\r\n"
	"  <td><a href=\"javascript:dig(7);\">7</a></td>\r\n"
	"  <td><a href=\"javascript:dig(8);\">8</a></td>\r\n"
	"  <td><a href=\"javascript:dig(9);\">9</a></td>\r\n"
	" </tr>\r\n"
	" <tr class=\"r3\">\r\n"
	"  <td><a class=\"t\" href=\"javascript:pwr();\">POWER</a></td>\r\n"
	"  <td><a href=\"javascript:dig(0);\">0</a></td>\r\n"
	"  <td><a class=\"t\" href=\"javascript:clr();\">CLEAR</a></td>\r\n"
	" </tr>\r\n"
	" <tr><td colspan=\"3\">\r\n"
	"  <table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n"
	"   <tr class=\"r2\">\r\n"
	"	<td><a href=\"javascript:sub(1);\">START</a></td>\r\n"
	"	<td width=\"5\"></td>\r\n"
	"	<td><a href=\"javascript:sub(0);\">STOP</a></td>\r\n"
	"   </tr>\r\n"
	"  </table>\r\n"
	" </td></tr>\r\n"
	"</table>\r\n"
	"<div><img src=\"bot.gif\" border=\"0\" /></div>\r\n"
	"<form id=\"f\" method=\"post\" action=\"ex%u\">"
	"<input id=\"fm\" type=\"hidden\" name=\"min\" value=\"0\" />"
	"<input id=\"fs\" type=\"hidden\" name=\"sec\" value=\"0\" />"
	"<input id=\"fp\" type=\"hidden\" name=\"pwr\" value=\"100\" />"
	"<input id=\"fr\" type=\"hidden\" name=\"run\" value=\"0\" />"
	"</form>";

static bool Ex4Post(const char * pszPost)
{	bool bStart = false;
	bool bStop = false;
	DWORD nMin = 0;
	DWORD nSec = 0;
	DWORD nPwr = 100;
	int i;
	if (! pszPost)
		return false;
	for (i=0; pszPost[i]; i++)
	{	if (_strnicmp(pszPost+i, "min=", 4) == 0)
			nMin = strtoul(pszPost+i+4, NULL, 10);
		else if (_strnicmp(pszPost+i, "sec=", 4) == 0)
			nSec = strtoul(pszPost+i+4, NULL, 10);
		else if (_strnicmp(pszPost+i, "pwr=", 4) == 0)
			nPwr = strtoul(pszPost+i+4, NULL, 10);
		else if (_strnicmp(pszPost+i, "run=", 4) == 0)
		{	if (strtoul(pszPost+i+4, NULL, 10))
				bStart = true;
			else
				bStop = true;
		}
	}
	if (bStart)
	{	if ((nMin || nSec) && nPwr > 0 && nPwr <= 100)
			EscStartRun((BYTE)nMin, (BYTE)nSec, (BYTE)nPwr);
		else
			bStart = false;
	} else if (bStop)
		EscStopRun();
	return bStart;
}

void PageEx4(SOCKET nSock, struct EscWebRequest * pReq)
{	bool bStart;
	char * p = pReq->m_pBuff;
	bStart = Ex4Post(pReq->m_pszPost);
	p += StdPageHead(p, "Microwave Timer Control");
	p += sprintf(p, szEx4, 4);
	if (bStart)
	{	p += sprintf(p,
			"<script>\r\n"
			"sDisp='");
		if (gnEscTimerMin)
			p += sprintf(p, "%2u%02u", gnEscTimerMin, gnEscTimerSec);
		else
			p += sprintf(p, "%4u", gnEscTimerSec);
		p += sprintf(p, "';\r\nnPwr=%u;\r\nDisplay();\r\nbRun=true;\r\n"
			"pv(nPwr/10);\r\n</script>\r\n", gnEscPower);
	}
	p += sprintf(p, "</body></html>");
	HttpHtmlResponse(nSock, pReq, p);
}
